//FirstView Component Constructor
function FirstView() {

	var IphoneImageCapture = require('/ui/common/IphoneImageCapture');
	var ImageCaptureUtils = require('/ui/common/IphoneImageCaptureUtils');

    var myView = Ti.UI.createView({
        backgroundColor: 'blue',
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        layout: 'vertical'
    });

    var myCapturedImageViewBorder = Ti.UI.createView({
        top: 0,
        backgroundColor: 'white',
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE
    });

    var myCapturedImageView = Ti.UI.createImageView({
        top: 5,
        height: 230,
        right: 5,
        left: 5,
        bottom: 5,
        width: Ti.UI.SIZE
    });

    
    myCapturedImageViewBorder.add(myCapturedImageView);

    var myCroppedImageViewBorder = Ti.UI.createView({
        top: 0,
        backgroundColor: 'white',
        width: Ti.UI.FILL,
        height: Ti.UI.SIZE
    });

    var myCroppedImageView = Ti.UI.createImageView({
        top: 5,
        height: Ti.UI.SIZE,
        right: 5,
        left: 5,
        bottom: 5,
        width: Ti.UI.SIZE
    });


    myCroppedImageViewBorder.add(myCroppedImageView);

    var success = function(capturedImage, originalImage, thumbnail){
    	Ti.API.error("Success Called");
        myCapturedImageView.setImage(originalImage);
        myCroppedImageView.setImage(capturedImage);


        var myCroppedImageViewLabel = Ti.UI.createLabel({
            top: 20,
            text: "IMAGE After Cropping",
            color: 'black',
            font: {fontSize: 30, font: 'Helvetica Neue'},
        });
        myCroppedImageView.add(myCroppedImageViewLabel);

        var myCaptureImageLabel = Ti.UI.createLabel({
            top: 20,
            text: "IMAGE CAPTURED FROM CAMERA",
            color: 'black',
            font: {fontSize: 30, font: 'Helvetica Neue'},
        });  

        myCapturedImageView.add(myCaptureImageLabel);
    };

    var processing = function(){
    	Ti.API.error("Processing Called");
    };

    var error = function(error){
    	Ti.API.error("Error Called: " + JSON.stringify(error));
    };

    var cancel = function(){
    	Ti.API.error("Cancel Called");
    };

    var args = {
    	success: success,
    	processing: processing,
    	error: error,
    	cancel: cancel,
    	overlayText: "I am the check deposit overlay text"
    };

 	var launchImageCapture = function(){
    	IphoneImageCapture.imageCapture(args);
    };

    var launchCameraButton = Ti.UI.createButton({
        top: 0,
        title: "Launch Camera",
    	height: 50,
    	width: Ti.UI.FILL
    });

    var isCameraSupported = Ti.UI.createButton({
        top: 0,
        title: "is Camera Supported",
        height: 50,
        width: Ti.UI.FILL
    });

    myView.add(launchCameraButton);
    myView.add(isCameraSupported);
    myView.add(myCapturedImageViewBorder);
    myView.add(myCroppedImageViewBorder);

    launchCameraButton.addEventListener('touchend', function(){
    	ImageCaptureUtils.getInstance(launchImageCapture);
    });

     isCameraSupported.addEventListener('touchend', function(){
        var isCameraSupported = Ti.Media.isCameraSupported;
        var alert = Ti.UI.createAlertDialog({
            title: 'Is Camera Supported?',
            message: isCameraSupported
        });
        alert.show();  
    });

    // launchCameraButton.fireEvent('touchend');
	
	return myView;
}

module.exports = FirstView;
